#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/types.h>
#include <time.h>
#include <sys/times.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <ctype.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <dirent.h>



#define VERSION "aspps 2005.05.17" 
#define EOLN '\n'

#define Unknown -1
#define Modified 2
#define True 1
#define False 0
#define	Debug 0

typedef enum {ATOM,CLAUSE,HORNCLAUSE,HORNATOM,META} nodeType ;

typedef struct Node {
	int index;
	nodeType	nType;
   struct Node	**metaList;
	int   requiredNegative;
	int	requiredPositive;
	int	metaCount;
	int	currentCount;
	int	currentPositive;
	int	currentNegative;
	char	*atomText;
	unsigned long weight;

	short isRequired;
	short	assignedValue;
	short	requiredValue;

	int	headCount;
	int	bodyCount;
	int	currentHeadCount;
	int	currentBodyCount;
	struct Node	**headList;
	struct Node	**bodyList;

} Node;



int	Restart=0;
int	Backtrack=0;
int	Answer=0;
int 	numberOfAtoms=0;
int	allAtoms=0;
int 	numberOfClauses=0;
int 	requiredSatisfiedClauses=0;
int  	currentSatisfiedClauses=0;
int	Count=0;
int	Cnt=0;
int	Maxlit=0;
int	Minlit=1000000;
int	propagateCount=0;
int	numberOfMetaAtoms=0;
int	numberOfRequiredHornAtoms=0;
int	clauseStackSize=0;
int	atomStackSize=0;
int	branchingStackSize=0;
int	requiredAtomsStackSize=0;

Node	*atomList=NULL;
Node 	*clauseList=NULL;
Node 	**clauseStack=NULL;
Node	**atomStack=NULL;
Node	**requiredAtomStack=NULL;
int	*literalList=NULL;
int	*branchingStack=NULL;
int	atomTop=0;
int	clauseTop=0;
int 	branchTop=0;
int 	requiredAtomTop=0;
unsigned long *Weight;

Node 	**propagateQueue=NULL;
int 	*propagateQueueValue=NULL;
int	*hornPathList=NULL;


int	Random =1;
int   Print=0;
int   Branch=0;
int	Depth=0;
int	Limit=0;
FILE  *errorFile=NULL;
FILE  *fptr=NULL;
int	atomsAssigned=0;
int	ShowCnt=0;
char	**ShowAtoms=NULL;

